# Class yii\db\pgsql\ArrayExpressionBuilder

Inheritance | yii\db\pgsql\ArrayExpressionBuilder
Implements | yii\db\ExpressionBuilderInterface
Uses Traits | yii\db\ExpressionBuilderTrait
Available since version | 2.0.14
Source Code | https://github.com/yiisoft/yii2/blob/master/framework/db/pgsql/ArrayExpressionBuilder.php

Class ArrayExpressionBuilder builds yii\db\ArrayExpression for PostgreSQL DBMS.

## Protected Properties

Hide inherited properties

Property | Type | Description | Defined By
--- | --- | --- | ---
$queryBuilder | yii\db\QueryBuilder |  | yii\db\ExpressionBuilderTrait

## Public Methods

Hide inherited methods

Method | Description | Defined By
--- | --- | ---
__construct() | ExpressionBuilderTrait constructor. | yii\db\ExpressionBuilderTrait
build() | Method builds the raw SQL from the $expression that will not be additionally escaped or quoted. | yii\db\pgsql\ArrayExpressionBuilder

## Protected Methods

Hide inherited methods

Method | Description | Defined By
--- | --- | ---
buildPlaceholders() | Builds placeholders array out of $expression values | yii\db\pgsql\ArrayExpressionBuilder
buildSubqueryArray() | Build an array expression from a subquery SQL. | yii\db\pgsql\ArrayExpressionBuilder
getTypehint() |  | yii\db\pgsql\ArrayExpressionBuilder
typecastValue() | Casts $value to use in $expression | yii\db\pgsql\ArrayExpressionBuilder

## Method Details

build() public method

Method builds the raw SQL from the $expression that will not be additionally escaped or quoted.

public string build ( yii\db\ExpressionInterface $expression, array &$params = [] )
$expression | yii\db\ArrayExpression|yii\db\ExpressionInterface | The expression to be built
$params | array | The binding parameters.
return | string | The raw SQL that will not be additionally escaped or quoted.

buildPlaceholders() protected method

Builds placeholders array out of $expression values

protected array buildPlaceholders ( yii\db\ExpressionInterface $expression, &$params )
$expression | yii\db\ExpressionInterface|yii\db\ArrayExpression |
$params | array | The binding parameters.

buildSubqueryArray() protected method

Build an array expression from a subquery SQL.

protected string buildSubqueryArray ( $sql, yii\db\ArrayExpression $expression )
$sql | string | The subquery SQL.
$expression | yii\db\ArrayExpression |
return | string | The subquery array expression.

getTypehint() protected method

protected string getTypehint ( yii\db\ArrayExpression $expression )
$expression | yii\db\ArrayExpression |
return | string | The typecast expression based on type.

typecastValue() protected method

Casts $value to use in $expression

protected yii\db\JsonExpression typecastValue ( yii\db\ArrayExpression $expression, $value )
$expression | yii\db\ArrayExpression |
$value | mixed |